.\" $XConsortium: Xmclinux.man,v 1.13 94/04/18 18:05:17 rws Exp $
.\" Copyright (c) 1989  X Consortium
.\" 
.\" Permission is hereby granted, free of charge, to any person obtaining
.\" a copy of this software and associated documentation files (the
.\" "Software"), to deal in the Software without restriction, including
.\" without limitation the rights to use, copy, modify, merge, publish,
.\" distribute, sublicense, and/or sell copies of the Software, and to
.\" permit persons to whom the Software is furnished to do so, subject to
.\" the following conditions:
.\" 
.\" The above copyright notice and this permission notice shall be included
.\" in all copies or substantial portions of the Software.
.\" 
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\" 
.\" Except as contained in this notice, the name of the X Consortium shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from the X Consortium.
.TH XPMAC 1 "Release 6" "X Version 11"
.SH NAME
Xpmac \- Server for X Version 11 under Linux on the Power Macintosh.
.SH SYNOPSIS
.B Xpmac
[ option ] ...
.SH DESCRIPTION
.I Xpmac
is the server for Version 11 of the X window system on Power
Macintoshes running PowerMac Linux or MkLinux.
It is normally started by the shell script
.IR startx.
.fi
.SH OPTIONS
.PP
In addition to the normal server options described in the \fIXserver(1)\fP
manual page, \fIXpmac\fP accepts the following command line switches:
.TP 8
.B \-mode \fInumber\fP \-depth \fInumber\fP
arranges that the given screen will operate at the given vmode and
depth. Supported depths are 8, 16 and 32. The server starts up, by
default, in the current video mode. This option must be used to modify
that behavior.
.TP 8
.B \-nooptionmouse
causes the mouse keys to generate mouse button presses without holding down
the option key.
.TP 8
.B \-middlekey [key], -rightkey [key]
Sets the decimal keycode for simulating the middle or right mouse buttons.
.B \-nooptionpower
disables the use of option+power to kill X. command+control+power will
still kill the server.
.TP 8
.B \-nomacgamma
disables gamma correction for Macintosh monitors
.TP 8
.B \-novtswitch
Disables virtual terminal switching via control+command+F[1-12].
.TP 8
.B \-keeptty
Use current virtual terminal and do not detach controlling tty on startup
.I
(for debugging only).
.TP 8
.B vtXX
Use the specified VT number on startup
.SH "BUTTON MAPPINGS"
Because most adb devices only have one button, the middle button can be
simulated by pressing option-2. Likewise, press option-3 for the right
button. These keys can be configured with commandline options.
.SH "SECURITY"
.I X
uses an access control list for deciding whether or not to accept a
connection from a given client.  This list
initially consists of the machine on which the server is running, and any
hosts listed in the file
\fI/etc/X0.hosts\fP
This file should contain one line
per host name, with no white space.  
.PP
The user can manipulate a dynamic form of this list in the server
using the \fIxhost(1)\fP program from
the same machine as the server.
.PP
Unlike some window systems, \fIX\fP does not have any notion of 
window operation permissions or
place any restrictions on what a client can do; if
a program can connect to a display, it has full run of the screen.  There
is support for using 
authentication services on connection startup beyond the simple host name
check, but it is not used in the standard distribution.
.SH "FONTS"
Fonts are stored in individual files in the directory(ies) named by
the font search path.  These files may be created by the \fIfc\fP utility.
The name of the file must correspond to the name of the font in lowercase
with the suffix ".pcf" appended.
Font files may be stored in \fIcompress\fP(1) format, in which case an
additional suffix (usually ".Z", defined when the server is built) must
be appended to the usual filename.
.SH "FILES"
.TP 30
<XRoot>/bin/X11
<XRoot>/bin/X11R6
Bourne shell scripts which start the server and initial 
.I xterm 
client.  <XRoot> refers to the root of the X11 install tree.
.TP 30
$HOME/.x11start 
Bourne shell script executed by initial 
.I xterm 
client which starts a slew of other clients. 
Reference copy in <XRoot>/lib/X11/.x11start
.TP 30
<XRoot>/bin/Xpmac 
the server binary
.TP 30
<XRoot>/bin/* 
client binaries
.TP 30
<XRoot>lib/X11/fonts/*
.TP 30
<XRoot>/lib/X11/rgb.{dir,pag,txt} 
color names to RGB mapping
.TP 30
/etc/X0.hosts
Initial access control list
.TP 30
/tmp/.X11-unix/X0
Unix domain socket
.TP 30
/usr/adm/X0msgs
Error log file
.TP 30
$HOME/.twmrc 
customization for the
.I twm
window manager. Reference copy in <XRoot>/lib/X11/Sample.twmrc
.TP 30
<XRoot>/lib/X11/XErrorDB 
client error message database
.TP 30
<XRoot>/lib/X11/app-defaults 
client specific resource specifications
.TP 30
<XRoot>/lib/X11/examples/Xaw/* 
source code examples of applications built on the
.I X
Toolkit
.TP 30
<XRoot>/lib/terminfo/x/xterm* 
.I terminfo
database entries descibing the terminal emulation capabilities of the
.I xterm
client. Reference copies in <XRoot>/lib/X11/xterm*.tic
.TP 30
<XRoot>/include/X11/bitmaps/*icon 
bitmap representations of icons used by the
.I twm
window manager
.SH "SEE ALSO"
xinit(1), X(1)
.SH AUTHORS
.TP 8
This X11R6.3 port is by:
Chris Penney <penney@colltech.com>
.TP 8
The current maintainer is:
Anthony Tong <atong@uiuc.edu>
.SH BUGS
.PP
In the unlikely event the server crashes,  
it may leave the keyboard and monitor in a non-useful state.
Use the 
.I screenrestore
command in an attempt to repair the damage.
.PP
Mode and depth switching may not be supported under Mklinux.
.PP
Please note that this man page may not be up to date.
