/* $XFree86: xc/programs/Xserver/hw/xfree86/vga256/drivers/mga/mga.h,v 3.3 1996/10/16 14:43:02 dawes Exp $ */

/*
 * MGA Millennium (MGA2064W) functions
 *
 * Copyright 1996 The XFree86 Project, Inc.
 *
 * Authors
 *		Dirk Hohndel
 *			hohndel@XFree86.Org
 *		David Dawes
 *			dawes@XFree86.Org
 */

#ifndef MGA_H
#define MGA_H

#define MGAREG8(addr) *(volatile CARD8 *)(MGAMMIOBase + (addr))
#define MGAREG16(addr) *(volatile CARD16 *)(MGAMMIOBase + (addr))
#define MGAREG32(addr) *(volatile CARD32 *)(MGAMMIOBase + (addr))
#define MGAREG(addr) MGAREG32(addr)
#define OUTREG(addr, val) MGAREG(addr) = (val)

extern unsigned char *MGAMMIOBase;
extern int MGAScrnWidth;
extern int inXpmac;
#define xf86VTSema inXpmac

#if defined (__powerpc__)
#define RESET()  { OUTREG(MGAREG_Reset, 1); usleep(20); OUTREG(MGAREG_Reset, 0); }
#define MGAWAITFIFO() while(MGAREG(MGAREG_FIFOSTATUS) & 0x00000100);
#define MGAWAITFREE()  while(MGAREG(MGAREG_Status) & 0x00010000);
#define MGAWAITFIFOSLOTS(SLOTS) while ( ((MGAREG(MGAREG_FIFOSTATUS) & 0x0000003f) - SLOTS) < 0 );
#else
#define MGAWAITFIFO() while(MGAREG16(MGAREG_FIFOSTATUS) & 0x100);
#define MGAWAITFREE() while(MGAREG8(MGAREG_Status + 2) & 0x01);
#define MGAWAITFIFOSLOTS(SLOTS) while ( ((MGAREG16(MGAREG_FIFOSTATUS) & 0x3f) - SLOTS) < 0 );
#endif

void
mgaLine (
#ifdef NeedFunctionPrototypes
	 DrawablePtr pDrawable, 
	 GCPtr pGC, 
	 int mode, 
	 int npt, 
	 DDXPointPtr pptInit
#endif
);

void
mgaPolyFillRect(
#ifdef NeedFunctionPrototypes
	DrawablePtr pDrawable,
	register GCPtr pGC,
	int         nrectFill,
	xRectangle  *prectInit
#endif
);                

void
mgaFillRectSolidCopy(
#ifdef NeedFunctionPrototypes
	DrawablePtr     pDrawable,
	GCPtr           pGC,
	int             nBox,
	BoxPtr          pBox
#endif
);

void
mgaPaintWindow(
#ifdef NeedFunctionPrototypes
	WindowPtr   pWin,
	RegionPtr   pRegion,
	int         what
#endif
);

void
mgaCopyWindow(
#ifdef NeedFunctionPrototypes
    WindowPtr pWin,
    DDXPointRec ptOldOrg,
    RegionPtr prgnSrc
#endif
);

void
mgaFillBoxSolid(
#ifdef NeedFunctionPrototypes
	DrawablePtr     pDrawable,
	int             nBox,
	BoxPtr          pBox,
	unsigned long   pixel
#endif
);                

int
MGAWaitForBlitter(
#ifdef NeedFunctionPrototypes
	void
#endif
);
#endif
