/* $XConsortium: mgapntwin.c /main/6 1996/10/28 07:27:38 kaleb $ */
/* $XFree86: xc/programs/Xserver/hw/xfree86/vga256/drivers/mga/mgapntwin.c,v 3.4 1996/10/23 13:10:34 dawes Exp $ */

#include "X.h"
#include "windowstr.h"
#include "regionstr.h"
#include "pixmapstr.h"
#include "scrnintstr.h"

#define PSZ 8
#include "../../cfb/cfb.h"
#include "cfb16.h"
#include "cfb32.h"
#include "../../include/gcstruct.h"
#include "../../cfb/cfbmskbits.h"

#include "mga.h"
#include "mgareg.h"

extern int vgaBitsPerPixel;

extern void cfb32FillBoxTile32();
extern void cfbFillBoxTile32();
extern void cfb32FillBoxTileOdd();
extern void cfbFillBoxTileOdd();


#define mgaFillBoxTile32 \
(vgaBitsPerPixel > 16?  cfb32FillBoxTile32 : \
(vgaBitsPerPixel == 16? cfb16FillBoxTile32 : cfbFillBoxTile32))
	
#define mgaFillBoxTileOdd \
(vgaBitsPerPixel > 16? cfb32FillBoxTileOdd : \
(vgaBitsPerPixel == 16? cfb16FillBoxTileOdd : cfbFillBoxTileOdd))
	
void
mgaFillBoxSolid (pDrawable, nBox, pBox, pixel)
    DrawablePtr	    pDrawable;
    int		    nBox;
    BoxPtr	    pBox;
    unsigned long   pixel;
{
	if(!xf86VTSema) 
		switch(vgaBitsPerPixel)
		{
		case 32:
			cfb32FillBoxSolid(pDrawable, nBox, pBox, pixel);
			return;
		case 16:
			cfb16FillBoxSolid(pDrawable, nBox, pBox, pixel);
			return;
		case 8:
			cfbFillBoxSolid(pDrawable, nBox, pBox, pixel);
					/* 0, GXcopy); */
			return;
		}
	
	switch(vgaBitsPerPixel)
	{
	case 16:
		pixel |= pixel << 16;
		break;
	case 8:
		pixel |= (pixel << 8) | (pixel << 16) | (pixel << 24);
		break;
	}

	MGAWAITFIFOSLOTS(4);
	
	MGAREG(MGAREG_CXBNDRY) = 0xFFFF0000;  /* (maxX << 16) | minX */
	MGAREG(MGAREG_YTOP) = 0x00000000;  /* minPixelPointer */
	MGAREG(MGAREG_YBOT) = 0x007FFFFF;  /* maxPixelPointer */
	
	MGAREG(MGAREG_FCOL) = pixel;
	
	for (; nBox; nBox--, pBox++)
	{
		int h = pBox->y2 - pBox->y1;
		
		MGAWAITFIFOSLOTS(3);
		MGAREG(MGAREG_FXBNDRY) = (pBox->x2 << 16) | pBox->x1;
		MGAREG(MGAREG_YDSTLEN) = (pBox->y1 << 16) | h;
#if 0  /* RK - for what? We've got fifos. */
		if(!MGAWaitForBlitter())
			ErrorF("MGA: BitBlt Engine timeout\n");
#endif
		MGAREG(MGAREG_DWGCTL + MGAREG_EXEC) = 0x000C7804;
		MGAWAITFREE();
	}
	MGAREG8(MGAREG_CACHEFLUSH) = 0;
}

void
mgaPaintWindow(pWin, pRegion, what)
    WindowPtr	pWin;
    RegionPtr	pRegion;
    int		what;
{
	register cfbPrivWin *pPrivWin;
	WindowPtr pBgWin;
	
	pPrivWin = cfbGetWindowPrivate(pWin);
	
	switch (what)
	{
	case PW_BACKGROUND:
		switch (pWin->backgroundState)
		{
		case None:
			break;
		case ParentRelative:
			do
			{
				pWin = pWin->parent;
			} while (pWin->backgroundState == ParentRelative);
			(*pWin->drawable.pScreen->PaintWindowBackground)(pWin,
					 		pRegion, what);
			break;
		case BackgroundPixmap:
			if (pPrivWin->fastBackground)
			{
				mgaFillBoxTile32 ((DrawablePtr)pWin,
					(int)REGION_NUM_RECTS(pRegion),
					REGION_RECTS(pRegion),
					pPrivWin->pRotatedBackground);
			}
			else
			{
				mgaFillBoxTileOdd ((DrawablePtr)pWin,
					(int)REGION_NUM_RECTS(pRegion),
					REGION_RECTS(pRegion),
					pWin->background.pixmap,
					(int) pWin->drawable.x,
					(int) pWin->drawable.y);
			}
			break;
		case BackgroundPixel:
			mgaFillBoxSolid ((DrawablePtr)pWin,
					(int)REGION_NUM_RECTS(pRegion),
					REGION_RECTS(pRegion),
					pWin->background.pixel);
					break;
		}
		break;
	case PW_BORDER:
		if (pWin->borderIsPixel)
		{
			mgaFillBoxSolid ((DrawablePtr)pWin,
				(int)REGION_NUM_RECTS(pRegion),
				REGION_RECTS(pRegion),
				pWin->border.pixel);
		}
		else if (pPrivWin->fastBorder)
		{
			mgaFillBoxTile32 ((DrawablePtr)pWin,
				(int)REGION_NUM_RECTS(pRegion),
				REGION_RECTS(pRegion),
				pPrivWin->pRotatedBorder);
		}
		else
		{
			for (pBgWin = pWin;
				pBgWin->backgroundState == ParentRelative;
				pBgWin = pBgWin->parent);

			mgaFillBoxTileOdd ((DrawablePtr)pWin,
				(int)REGION_NUM_RECTS(pRegion),
				REGION_RECTS(pRegion),
				pWin->border.pixmap,
				(int) pBgWin->drawable.x,
				(int) pBgWin->drawable.y);
		}
		break;
	}
}



extern WindowPtr *WindowTable;

void
mgaCopyWindow(pWin, ptOldOrg, prgnSrc)
    WindowPtr pWin;
    DDXPointRec ptOldOrg;
    RegionPtr prgnSrc;
{
    DDXPointPtr pptSrc;
    register DDXPointPtr ppt;
    RegionRec rgnDst;
    register BoxPtr pbox;
    register int dx, dy;
    register int i, nbox;
    WindowPtr pwinRoot;


    pwinRoot = WindowTable[pWin->drawable.pScreen->myNum];

    REGION_INIT(pWin->drawable.pScreen, &rgnDst, NullBox, 0);

    dx = ptOldOrg.x - pWin->drawable.x;
    dy = ptOldOrg.y - pWin->drawable.y;
    REGION_TRANSLATE(pWin->drawable.pScreen, prgnSrc, -dx, -dy);
    REGION_INTERSECT(pWin->drawable.pScreen, &rgnDst, &pWin->borderClip, prgnSrc);

    pbox = REGION_RECTS(&rgnDst);
    nbox = REGION_NUM_RECTS(&rgnDst);
    if (!nbox || !(pptSrc = (DDXPointPtr) ALLOCATE_LOCAL(nbox * sizeof(DDXPointRec)))) {
	REGION_UNINIT(pWin->drawable.pScreen, &rgnDst);
	return;
    }
    ppt = pptSrc;

    for (i = nbox; --i >= 0; ppt++, pbox++) {
	ppt->x = pbox->x1 + dx;
	ppt->y = pbox->y1 + dy;
    }

    MGADoBitbltCopy((DrawablePtr) pwinRoot, (DrawablePtr) pwinRoot,
	GXcopy, &rgnDst, pptSrc, ~0L);
    DEALLOCATE_LOCAL(pptSrc);
    REGION_UNINIT(pWin->drawable.pScreen, &rgnDst);
}
