#define CONFIG_FB_MATROX
#include	"X.h"
#include	"Xmd.h"
#include	"Xproto.h"
#include	"gcstruct.h"
#include	"windowstr.h"
#include	"scrnintstr.h"
#include	"pixmapstr.h"
#include	"regionstr.h"

#define PSZ 8
#include	"../../cfb/cfb.h"
#include	"cfb16.h"
#if defined(CONFIG_CFB24)
#include	"cfb24.h"
#endif
#include	"cfb32.h"

#include <asm/vc_ioctl.h>
#include <string.h>
#include "mgareg.h"
#include "mga.h"

extern void (*stdDoBitbltCopy)();
int MGAScrnWidth;
unsigned char *MGAMMIOBase = 0;
int vgaBitsPerPixel;
int vgaBytesPerPixel;
int MGAydstorg;
int MGAinterleave = 1;
int MGAMaxFastBlitY;
int MGABppShift;

extern GCOps cfb32TEOps1Rect, cfb32TEOps, cfb32NonTEOps1Rect, cfb32NonTEOps,
	     cfb24TEOps1Rect, cfb24TEOps, cfb24NonTEOps1Rect, cfb24NonTEOps,
	     cfb16TEOps1Rect, cfb16TEOps, cfb16NonTEOps1Rect, cfb16NonTEOps,
	     cfbTEOps1Rect,   cfbTEOps,   cfbNonTEOps1Rect,   cfbNonTEOps;
int fix4mbBoundary = FALSE;


void MGABlitterInit(struct vc_mode mode, unsigned char **framebuffer)
{
    int bpp = mode.depth, width = mode.width, height = mode.height;
    int shift, pitch = mode.pitch;
    int BytesPerPixel, offset, offset_modulo, ydstorg_modulo;
    unsigned int opmode;
    int maxFastBlitMem =  (MGAinterleave ? 4096 : 2048) * 1024;

    if(framebuffer) {
      if(strncmp(mode.name, "MTRX", 4)) {
	MGAMMIOBase = 0;
	return;
      }
      else if(mode.disp_reg_address < 0x80000000) {
	MGAMMIOBase = 0;
	return;
      }
      ErrorF("Millennium detected. Mapping MGA2x64W regsiter...\n");
      if (pmacMapDispRegs(&MGAMMIOBase, mode.disp_reg_address, 0x4000)) {
	ErrorF("Warnig: Couldn't map MGA2164W register. Acceleration disabled.\n");
	MGAMMIOBase = 0;
	return;
      }
      ErrorF("MGA2164W register successfully mapped. Starting acceleration...\n");
    }
    if(!MGAMMIOBase)
      return;

    switch(bpp) {
      case 16:
        stdDoBitbltCopy = cfb16DoBitbltCopy;
	/* set 16 bpp, turn off dithering, turn on 5:5:5 pixels */
        shift = 1 + (1 << 30) + (1 << 31);
	MGABppShift = 1;
	opmode = 0x00010100;
	vgaBitsPerPixel = 16;
	break;
      case 24:
      case 32:
        stdDoBitbltCopy = cfb32DoBitbltCopy;
        shift = 2;
	MGABppShift = 2;
	opmode = 0x00020200;
	vgaBitsPerPixel = 32;
	break;
      default:
        stdDoBitbltCopy = cfbDoBitbltCopy;
        shift = 0;
	MGABppShift = 0;
	opmode = 0x00000000;
	vgaBitsPerPixel = 8;
	break;
    }
    MGAScrnWidth = pitch >> MGABppShift;
    BytesPerPixel = vgaBitsPerPixel / 8;

    MGAydstorg = 0;
    if(fix4mbBoundary) {
      if (MGAScrnWidth*height*BytesPerPixel > 4*1024*1024) {
	offset = (4*1024*1024) % (width * BytesPerPixel);
	offset_modulo = 4;
	ydstorg_modulo = 64;
	if (vgaBitsPerPixel == 24)
	  offset_modulo *= 3;
	offset_modulo <<= 1;
	ydstorg_modulo <<= 1;
	MGAydstorg = offset / BytesPerPixel;
	while ((offset % offset_modulo) != 0 || (MGAydstorg % ydstorg_modulo) != 0) {
	  offset++;
	  MGAydstorg = offset / BytesPerPixel;
	}
      }
    }

    MGAMaxFastBlitY = maxFastBlitMem/(MGAScrnWidth*BytesPerPixel);
    opmode |= MGAOPM_DMA_BLIT;

    MGAWAITFIFOSLOTS(10);
    MGAREG(MGAREG_FCOL) = 0x00000000;
    MGAREG(MGAREG_SHIFT) = 0x00000000;
    MGAREG(MGAREG_OPMODE) = opmode;
    MGAREG(MGAREG_MACCESS) = shift;
    MGAREG(MGAREG_YDSTORG) = MGAydstorg;
    MGAREG(MGAREG_PLNWT) = 0xFFFFFFFF;
    MGAREG(MGAREG_PITCH) = MGAScrnWidth;
    MGAREG(MGAREG_CXBNDRY) = 0xFFFF0000;  /* (maxX << 16) | minX */
    MGAREG(MGAREG_YTOP) = 0x00000000;  /* minPixelPointer */
    MGAREG(MGAREG_YBOT) = 0x007FFFFF;  /* maxPixelPointer */
}


void MGAInitGC(void)
{
  switch(vgaBitsPerPixel) {
    case 8:
      cfbTEOps.CopyArea = MGACopyArea;
      cfbNonTEOps.CopyArea = MGACopyArea;
      cfbTEOps1Rect.CopyArea = MGACopyArea;
      cfbNonTEOps1Rect.CopyArea = MGACopyArea;
      cfbTEOps.PolyFillRect = mgaPolyFillRect;
      cfbNonTEOps.PolyFillRect = mgaPolyFillRect;
      cfbTEOps1Rect.PolyFillRect = mgaPolyFillRect;
      cfbNonTEOps1Rect.PolyFillRect = mgaPolyFillRect;
      break;
    case 16:
      cfb16TEOps.CopyArea = MGACopyArea;
      cfb16NonTEOps.CopyArea = MGACopyArea;
      cfb16TEOps1Rect.CopyArea = MGACopyArea;
      cfb16NonTEOps1Rect.CopyArea = MGACopyArea;
      cfb16TEOps.PolyFillRect = mgaPolyFillRect;
      cfb16NonTEOps.PolyFillRect = mgaPolyFillRect;
      cfb16TEOps1Rect.PolyFillRect = mgaPolyFillRect;
      cfb16NonTEOps1Rect.PolyFillRect = mgaPolyFillRect;
      break;
    case 24:
    case 32:
      cfb32TEOps.CopyArea = MGACopyArea;
      cfb32NonTEOps.CopyArea = MGACopyArea;
      cfb32TEOps1Rect.CopyArea = MGACopyArea;
      cfb32NonTEOps1Rect.CopyArea = MGACopyArea;
      cfb32TEOps.PolyFillRect = mgaPolyFillRect;
      cfb32NonTEOps.PolyFillRect = mgaPolyFillRect;
      cfb32TEOps1Rect.PolyFillRect = mgaPolyFillRect;
      cfb32NonTEOps1Rect.PolyFillRect = mgaPolyFillRect;
      break;
  }
}
