/* $XFree86: xc/programs/Xserver/hw/xfree86/accel/mach64/mach64.h,v 3.14.2.2 1998/02/23 19:06:00 hohndel Exp $ */
/*
 * Copyright 1992,1993,1994,1995,1996,1997 by Kevin E. Martin, Chapel Hill, North Carolina.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of Kevin E. Martin not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Kevin E. Martin
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * KEVIN E. MARTIN AND RICKARD E. FAITH DISCLAIM ALL WARRANTIES WITH
 * REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL KEVIN E. MARTIN BE
 * LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Modified for the Mach-8 by Rickard E. Faith (faith@cs.unc.edu)
 * Modified for the Mach32 by Kevin E. Martin (martin@cs.unc.edu)
 * Modified for the Mach64 by Kevin E. Martin (martin@cs.unc.edu)
 */
/* $XConsortium: mach64.h /main/9 1996/10/27 18:06:13 kaleb $ */
/* Modified for the Rage128 by Ryuichi Oikawa (roikawa@rr.iij4u.or.jp) */

#ifndef RAGE128_H
#define RAGE128_H

/* #define RAGE128_BIG_ENDIAN */

#define RAGE128_PATCHLEVEL "0"

#define RAGE128_CURSBYTES	1024
#define RAGE128_CURSMAX		64

#include "X.h"
#include "input.h"
#include "pixmap.h"
#include "region.h"
#include "gc.h"
#include "gcstruct.h"
#include "colormap.h"
#include "colormapst.h"
#include "miscstruct.h"
#include "scrnintstr.h"
#include "servermd.h"
#include "windowstr.h"
/*#include "misc.h"*/
/*#include "xf86.h"*/
/*#include "regionstr.h"*/
/*#include "xf86_OSlib.h"*/
/*#include "xf86Procs.h"*/

#include "regionstr.h"
#include "regrage128.h"
#define xf86VTSema inXpmac

extern pointer rage128VideoMem;
extern pointer rage128MemReg;
extern pointer vgaBase;
extern int inXpmac;
extern int rage128MaxX, rage128MaxY;
extern int rage128VirtX, rage128VirtY;
extern int rage128DataType;
extern Bool rage128DAC8Bit;
extern unsigned int rage128LinearOffset;

#ifdef PIXPRIV
extern int rage128PixmapIndex;
#endif

#if 0
extern int rage128Ramdac;
extern int rage128RamdacSubType;
extern int rage128BusType;
extern int rage128MemType;
extern int rage128ChipType;
extern int rage128ChipRev;
extern int rage128ClockType;
extern int rage128Clocks[RAGE128_NUM_CLOCKS];
extern int rage128MinFreq;
extern int rage128MaxFreq;
extern int rage128RefFreq;
extern int rage128RefDivider;
extern int rage128NAdj;
extern int rage128CXClk;
extern int rage128MemClk;
extern int rage128DRAMMemClk;
extern int rage128VRAMMemClk;
extern int rage128MemCycle;
#endif

extern Bool rage128IntegratedController;
extern Bool rage128HasDSP;

extern unsigned int rage128MemorySize;
extern unsigned int rage128ApertureSize;
extern unsigned long rage128ApertureAddr;
extern unsigned long rage128RegisterAddr;

extern short rage128WeightMask;

#if 0
extern ScrnInfoRec rage128InfoRec;
extern int rage128ValidTokens[];
#endif

extern int rage128alu[];
extern int rage128alup[];

extern Bool checkCursorColor;

extern int vgaBitsPerPixel;
extern int rage128BitDepth;


extern void (*rage128ImageReadFunc)(
#if NeedFunctionPrototypes
    int,
    int,
    int,
    int,
    char *,
    int,
    int,
    int,
    unsigned long
#endif 
);

extern void (*rage128ImageWriteFunc)(
#if NeedFunctionPrototypes
    int,
    int,
    int,
    int,
    char *,
    int,
    int,
    int,
    int,
    unsigned long
#endif 
);

/* Function Prototypes */
#if 0
/* rage128.c */
Bool rage128Probe(
#if NeedFunctionPrototypes
    void
#endif
);
void rage128PrintIdent(
#if NeedFunctionPrototypes
    void
#endif
);
Bool rage128Initialize(
#if NeedFunctionPrototypes
    int scr_index,
    ScreenPtr pScreen,
    int argc,
    char **argv
#endif
);
void rage128EnterLeaveVT(
#if NeedFunctionPrototypes
    Bool enter,
    int screen_idx
#endif
);
Bool rage128CloseScreen(
#if NeedFunctionPrototypes
    int screen_idx,
    ScreenPtr pScreen
#endif
);
Bool rage128SaveScreen(
#if NeedFunctionPrototypes
    ScreenPtr pScreen,
    Bool on
#endif
);
void rage128AdjustFrame(
#if NeedFunctionPrototypes
    int x,
    int y
#endif
);
Bool rage128SwitchMode(
#if NeedFunctionPrototypes
    DisplayModePtr mode
#endif
);
void rage128DPMSSet(
#if NeedFunctionPrototypes
    int PowerManagementMode
#endif
);
/* rage128cmap.c */
int rage128ListInstalledColormaps(
#if NeedFunctionPrototypes
    ScreenPtr pScreen,
    Colormap *pmaps
#endif
);
int rage128GetInstalledColormaps(
#if NeedFunctionPrototypes
    ScreenPtr pScreen,
    ColormapPtr *pmap
#endif
);
void rage128StoreColors(
#if NeedFunctionPrototypes
    ColormapPtr pmap,
    int ndef,
    xColorItem *pdefs
#endif
);
void rage128InstallColormap(
#if NeedFunctionPrototypes
    ColormapPtr pmap
#endif
);
void rage128UninstallColormap(
#if NeedFunctionPrototypes
    ColormapPtr pmap
#endif
);
void rage128RestoreColor0(
#if NeedFunctionPrototypes
    ScreenPtr pScreen
#endif
);
#endif  /* 0 */

/* rage128gc.c */
void rage128InitGC(
#if NeedFunctionPrototypes
    void
#endif
);
Bool rage128CreateGC(
#if NeedFunctionPrototypes
    register GCPtr pGC
#endif
);
/* rage128fs.c */
void rage128SolidFSpans(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    GCPtr pGC,
    int nInit,
    DDXPointPtr pptInit,
    int *pwidthInit,
    int fSorted
#endif
);
void rage128TiledFSpans(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    GCPtr pGC,
    int nInit,
    DDXPointPtr pptInit,
    int *pwidthInit,
    int fSorted
#endif
);
void rage128StipFSpans(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    GCPtr pGC,
    int nInit,
    DDXPointPtr pptInit,
    int *pwidthInit,
    int fSorted
#endif
);
void rage128OStipFSpans(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    GCPtr pGC,
    int nInit,
    DDXPointPtr pptInit,
    int *pwidthInit,
    int fSorted
#endif
);
/* rage128win.c */
void rage128CopyWindow(
#if NeedFunctionPrototypes
    WindowPtr pWin,
    DDXPointRec ptOldOrg,
    RegionPtr prgnSrc
#endif
);
/* rage128init.c */

#if 0
void rage128CalcCRTCRegs(
#if NeedFunctionPrototypes
    rage128CRTCRegPtr crtcRegs,
    DisplayModePtr mode
#endif
);
void rage128SetCRTCRegs(
#if NeedFunctionPrototypes
    rage128CRTCRegPtr crtcRegs
#endif
);
void rage128SaveLUT(
#if NeedFunctionPrototypes
    LUTENTRY *lut
#endif
);
void rage128RestoreLUT(
#if NeedFunctionPrototypes
    LUTENTRY *lut
#endif
);
void rage128InitLUT(
#if NeedFunctionPrototypes
    void
#endif
);
void rage128InitEnvironment(
#if NeedFunctionPrototypes
    void
#endif
);
void rage128InitAperture(
#if NeedFunctionPrototypes
    int screen_idx
#endif
);
void rage128P_RGB514Index(
#if NeedFunctionPrototypes
    int index,
    int data
#endif
);
unsigned char rage128R_RGB514Index(
#if NeedFunctionPrototypes
    int index
#endif
);
void rage128SetRamdac(
#if NeedFunctionPrototypes
    int colorDepth,
    int AccelMode,
    int dotClock
#endif
);
void rage128InitDisplay(
#if NeedFunctionPrototypes
    int screen_idx
#endif
);
void rage128CleanUp(
#if NeedFunctionPrototypes
    void
#endif
);
#endif  /* 0 */

/* rage128im.c */
void rage128ImageInit(
#if NeedFunctionPrototypes
    void
#endif
);
void rage128ImageStippleFunc(
#if NeedFunctionPrototypes
    int x,
    int y,
    int w,
    int h,
    char *psrc,
    int pwidth,
    int px,
    int py,
    Pixel fgPixel,
    Pixel bgPixel,
    int alu,
    unsigned long planemask,
    int opaque
#endif
);


#if 0
/* rage128bstor.c */
void rage128SaveAreas(
#if NeedFunctionPrototypes
    PixmapPtr pPixmap,
    RegionPtr prgnSave,
    int xorg,
    int yorg,
    WindowPtr pWin
#endif
);
void rage128RestoreAreas(
#if NeedFunctionPrototypes
    PixmapPtr pPixmap,
    RegionPtr prgnRestore,
    int xorg,
    int yorg,
    WindowPtr pWin
#endif
);
/* rage128scrin.c */
Bool rage128ScreenInit(
#if NeedFunctionPrototypes
    register ScreenPtr pScreen,
    pointer pbits,
    int xsize,
    int ysize,
    int dpix,
    int dpiy,
    int width
#endif
);
#endif /* 0 */


/* rage128blt.c */
RegionPtr rage128CopyArea(
#if NeedFunctionPrototypes
    register DrawablePtr pSrcDrawable,
    register DrawablePtr pDstDrawable,
    GC *pGC,
    int srcx,
    int srcy,
    int width,
    int height,
    int dstx,
    int dsty
#endif
);
void rage128DoBitBlt(
#if NeedFunctionPrototypes
    DrawablePtr pSrc,
    DrawablePtr pDst,
    GC *pGC,
    RegionPtr rgnDst,
    DDXPointPtr pptSrc,
    unsigned long bitPlane
#endif
);
RegionPtr rage128CopyPlane(
#if NeedFunctionPrototypes
    DrawablePtr pSrcDrawable,
    DrawablePtr pDstDrawable,
    GCPtr pGC,
    int srcx,
    int srcy,
    int width,
    int height,
    int dstx,
    int dsty,
    unsigned long bitPlane
#endif
);
#if 0
/* rage128pcach.c */
void rage128CacheInit(
#if NeedFunctionPrototypes
    int w,
    int h 
#endif
);
void rage128CacheFreeSlot(
#if NeedFunctionPrototypes
    PixmapPtr pix
#endif
);
void rage128IncrementCacheLRU(
#if NeedFunctionPrototypes
    int slot
#endif
);
int rage128CacheTile(
#if NeedFunctionPrototypes
    PixmapPtr pix
#endif
);
int rage128CacheStipple(
#if NeedFunctionPrototypes
    PixmapPtr pix,
    int fg
#endif
);
int rage128CacheOpStipple(
#if NeedFunctionPrototypes
    PixmapPtr pix,
    int fg,
    int bg
#endif
);
#endif /* 0 */

/* rage128line.c */
void rage128Line(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    GCPtr pGC,
    int mode,
    int npt,
    DDXPointPtr pptInit
#endif
);
/* rage128seg.c */
void rage128Segment(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    GCPtr pGC,
    int nseg,
    register xSegment *pSeg
#endif
);
/* rage128orect.c */
void rage128PolyRectangle(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    register GCPtr pGC,
    int nRectsInit,
    xRectangle *pRectsInit
#endif
);
/* rage128frect.c */
void rage128PolyFillRect(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    register GCPtr pGC,
    int nrectFill,
    xRectangle *prectInit
#endif
);

#if 0
/* rage128text.c */
int rage128PolyText8(
#if NeedFunctionPrototypes
    DrawablePtr,
    GCPtr,
    int,
    int,
    int,
    char *
#endif
);
int rage128PolyText16(
#if NeedFunctionPrototypes
    DrawablePtr,
    GCPtr,
    int,
    int,
    int,
    unsigned short *
#endif
);
void rage128ImageText8(
#if NeedFunctionPrototypes
    DrawablePtr,
    GCPtr,
    int,
    int,
    int,
    char *
#endif
);
void rage128ImageText16(
#if NeedFunctionPrototypes
    DrawablePtr,
    GCPtr,
    int,
    int,
    int,
    unsigned short *
#endif
);
/* rage128font.c */
Bool rage128RealizeFont(
#if NeedFunctionPrototypes
    ScreenPtr pScreen,
    FontPtr font
#endif
);
Bool rage128UnrealizeFont(
#if NeedFunctionPrototypes
    ScreenPtr pScreen,
    FontPtr font
#endif
);
/* rage128fcache.c */
void rage128FontCache8Init(
#if NeedFunctionPrototypes
    int x,
    int y
#endif
);
int rage128CacheFont(
#if NeedFunctionPrototypes
    FontPtr font
#endif
);
void rage128UnCacheFont(
#if NeedFunctionPrototypes
    FontPtr font
#endif
);
int rage128DrawText(
#if NeedFunctionPrototypes
    DrawablePtr,
    GCPtr,
    int,
    int,
    int,
    unsigned char *,
    int,
    int
#endif
);
#endif /* 0 */

/* rage128pntwn.c */
void rage128PaintWindow(
#if NeedFunctionPrototypes
    WindowPtr pWin,
    RegionPtr pRegion,
    int what
#endif
);

#if 0
/* ativga.c */
void rage128SaveVGAInfo(
#if NeedFunctionPrototypes
    int screen_idx
#endif
);
void rage128RestoreVGAInfo(
#if NeedFunctionPrototypes
    void
#endif
);
/* rage128curs.c */
Bool rage128CursorInit(
#if NeedFunctionPrototypes
    char *pm,
    ScreenPtr pScr
#endif
);
Bool rage128RealizeCursor(
#if NeedFunctionPrototypes
    ScreenPtr pScr,
    CursorPtr pCurs
#endif
);
Bool rage128UnrealizeCursor(
#if NeedFunctionPrototypes
    ScreenPtr pScr,
    CursorPtr pCurs
#endif
);
void rage128SetCursor(
#if NeedFunctionPrototypes
    ScreenPtr pScr,
    CursorPtr pCurs,
    int x,
    int y
#endif
);
void rage128RepositionCursor(
#if NeedFunctionPrototypes
    ScreenPtr pScr
#endif
);
void rage128RestoreCursor(
#if NeedFunctionPrototypes
    ScreenPtr pScr
#endif
);
void rage128MoveCursor(
#if NeedFunctionPrototypes
    ScreenPtr pScr,
    int x,
    int y
#endif
);
void rage128RenewCursorColor(
#if NeedFunctionPrototypes
    ScreenPtr pScr
#endif
);
void rage128RecolorCursor(
#if NeedFunctionPrototypes
    ScreenPtr pScr,
    CursorPtr pCurs,
    Bool displayed
#endif
);
void rage128WarpCursor(
#if NeedFunctionPrototypes
    ScreenPtr pScr,
    int x,
    int y
#endif
);
void rage128QueryBestSize(
#if NeedFunctionPrototypes
    int class,
    unsigned short *pwidth,
    unsigned short *pheight,
    ScreenPtr pScr
#endif
);
void rage128CursorOff(
#if NeedFunctionPrototypes
    void
#endif
);
void rage128ClearSavedCursor(
#if NeedFunctionPrototypes
    int scr_index
#endif
);
extern void rage128BlockHandler(
#if NeedFunctionPrototypes
    int i,
    pointer blockData,
    struct timeval ** pTimeout,
    pointer pReadmask
#endif
);
#endif /* 0 */

/* rage128gtimg.c */
void rage128GetImage(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    int sx,
    int sy,
    int w,
    int h,
    unsigned int format,
    unsigned long planeMask,
    char * pdstLine
#endif
);
/* rage128dline.c  --  NOT IMPLEMENTED */
void rage128Dline(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    GCPtr pGC,
    int mode,
    int npt,
    DDXPointPtr pptInit
#endif
);
/* rage128dseg.c   --  NOT IMPLEMENTED */
void rage128Dsegment(
#if NeedFunctionPrototypes
    DrawablePtr pDrawable,
    GCPtr pGC,
    int nseg,
    register xSegment *pSeg
#endif
);
#endif
