#if defined(linux) || defined(__linux__) || defined(LinuxArchitecture)
#include <stdio.h>
#include "videoprobe.h"

struct pci_device_tag *ProbeVideoByAddress(int vendor_id, int device_id, int mem_base_idx,
				  unsigned long phys_address, unsigned long address_mask)
{
  FILE *pciInfo;
  char buf[512];
  unsigned int bus, devfn, vendor, device, irq, base_address[6], rom_base;
  int i;
  static struct pci_device_tag pci_device;

  if(!(pciInfo = fopen(PCI_INFO_NAME, "r")))
    return((struct pci_device_tag *)NULL);

  while(fgets(buf, 510, pciInfo)) {
    sscanf(buf, "%02x%02x\t%04x%04x\t%x\t%08lx\t%08lx\t%08lx\t%08lx\t%08lx\t%08lx\t%08lx", 
	   &bus, &devfn, &vendor, &device, &irq,
	   &base_address[0],
	   &base_address[1],
	   &base_address[2],
	   &base_address[3],
	   &base_address[4],
	   &base_address[5],
	   &rom_base);
    if(vendor == vendor_id && device == device_id &&
       ((unsigned long)phys_address & address_mask) == (base_address[mem_base_idx] & address_mask))
	break;
  }
  if(feof(pciInfo)) {
    fclose(pciInfo);
    return((struct pci_device_tag *)NULL);
  }
  fclose(pciInfo);
  pci_device.bus = bus;
  pci_device.devfn = devfn;
  pci_device.vendor = vendor;
  pci_device.device = device;
  for(i = 0; i < 6; i++)
    pci_device.base_address[i] = base_address[i];
  pci_device.rom_base = rom_base;
  return(&pci_device);
}
#else
struct pci_device_tag *ProbeVideoByAddress(int vendor_id, int device_id, int mem_base_idx,
				  unsigned char *phys_address, unsigned long address_mask)
{
  return((struct pci_device_tag *)NULL);
}
#endif


